#pragma once

#include "resource.h"

typedef bool (*PFNINSTALLHOOK)(const DWORD);
typedef bool (*PFNREMOVEHOOK)(void);
typedef bool (*PFNSCANPASSWORD)(const HWND, const HWND);

//***********************************************
class CHookDllInterface
{
public:
	CHookDllInterface();
	virtual ~CHookDllInterface();

	bool InstallHook(const DWORD dwThreadId);
	bool RemoveHook(void);
	bool ScanPassword(const HWND hWnd, const HWND hPwdSpyWnd);

protected:
	HMODULE m_hModHookDll;
	PTSTR m_szPwdSpyHkDll;
	PFNINSTALLHOOK m_pfnInstallHook;
	PFNREMOVEHOOK m_pfnRemoveHook;
	PFNSCANPASSWORD m_pfnScanPassword;

	static bool ExtractResource(const HINSTANCE hInstance, const WORD nID, PCTSTR szFilename);
};
